diff --git a/src/cargopacket.h b/src/cargopacket.h
--- a/src/cargopacket.h
+++ b/src/cargopacket.h
@@ -15,8 +15,11 @@
 #include "core/pool_type.hpp"
 #include "economy_type.h"
 #include "station_type.h"
+#include "order_type.h"
 #include "cargo_type.h"
+#include "cargotype.h"
 #include "vehicle_type.h"
+#include "core/multimap.hpp"
 #include <list>
 
 /** Unique identifier for a single cargo packet. */
@@ -28,7 +31,9 @@
 /** The actual pool with cargo packets. */
 extern CargoPacketPool _cargopacket_pool;
 
-template <class Tinst> class CargoList;
+template <class Tinst, class Tcont> class CargoList;
+class StationCargoList; // forward-declare, so we can use it in VehicleCargoList::Unreserve
+class VehicleCargoList; // forward-declare, so we can use it in CargoList::MovePacket
 extern const struct SaveLoad *GetCargoPacketDesc();
 
 /**
@@ -46,7 +51,7 @@
 	TileIndex loaded_at_xy;     ///< Location where this cargo has been loaded into the vehicle.
 
 	/** The CargoList caches, thus needs to know about it. */
-	template <class Tinst> friend class CargoList;
+	template <class Tinst, class Tcont> friend class CargoList;
 	friend class VehicleCargoList;
 	friend class StationCargoList;
 	/** We want this to be saved, right? */
@@ -140,7 +145,6 @@
 		return this->loaded_at_xy;
 	}
 
-
 	static void InvalidateAllFrom(SourceType src_type, SourceID src);
 	static void InvalidateAllFrom(StationID sid);
 	static void AfterLoad();
@@ -159,38 +163,46 @@
  */
 #define FOR_ALL_CARGOPACKETS(var) FOR_ALL_CARGOPACKETS_FROM(var, 0)
 
+/** Kind of actions that could be done with packets on unloading */
+enum UnloadType {
+	UL_KEEP     = 0,      ///< Keep cargo on vehicle.
+	UL_DELIVER  = 1 << 0, ///< Deliver cargo.
+	UL_TRANSFER = 1 << 1, ///< Transfer cargo.
+	UL_ACCEPTED = 1 << 2, ///< Cargo is accepted.
+};
+
 /**
  * Simple collection class for a list of cargo packets.
  * @tparam Tinst Actual instantation of this cargo list.
  */
-template <class Tinst>
+template <class Tinst, class Tcont>
 class CargoList {
 public:
-	/** Container with cargo packets. */
-	typedef std::list<CargoPacket *> List;
-	/** The iterator for our container. */
-	typedef List::iterator Iterator;
-	/** The const iterator for our container. */
-	typedef List::const_iterator ConstIterator;
-
-	/** Kind of actions that could be done with packets on move. */
-	enum MoveToAction {
-		MTA_FINAL_DELIVERY, ///< "Deliver" the packet to the final destination, i.e. destroy the packet.
-		MTA_CARGO_LOAD,     ///< Load the packet onto a vehicle, i.e. set the last loaded station ID.
-		MTA_TRANSFER,       ///< The cargo is moved as part of a transfer.
-		MTA_UNLOAD,         ///< The cargo is moved as part of a forced unload.
-	};
+	/** Iterator for our container. */
+	typedef typename Tcont::iterator Iterator;
+	/** Const iterator for our container. */
+	typedef typename Tcont::const_iterator ConstIterator;
+	/** Reverse iterator for our container. */
+	typedef typename Tcont::reverse_iterator ReverseIterator;
+	/** Const reverse iterator for our container. */
+	typedef typename Tcont::const_reverse_iterator ConstReverseIterator;
 
 protected:
-	uint count;                 ///< Cache for the number of cargo entities.
+	uint count;					///< Cache for the number of cargo entities.
 	uint cargo_days_in_transit; ///< Cache for the sum of number of days in transit of each entity; comparable to man-hours.
 
-	List packets;               ///< The cargo packets in this list.
+	Tcont packets;				///< The cargo packets in this list.
 
 	void AddToCache(const CargoPacket *cp);
 
 	void RemoveFromCache(const CargoPacket *cp);
 
+	CargoPacket *RemovePacket(Iterator &it, uint cap, TileIndex load_place = INVALID_TILE);
+
+	uint MovePacket(StationCargoList *dest, StationID next, Iterator &it, uint cap);
+
+	uint MovePacket(VehicleCargoList *dest, Iterator &it, uint cap, TileIndex load_place = INVALID_TILE, bool reserved = false);
+
 public:
 	/** Create the cargo list. */
 	CargoList() {}
@@ -203,7 +215,7 @@
 	 * Returns a pointer to the cargo packet list (so you can iterate over it etc).
 	 * @return Pointer to the packet list.
 	 */
-	FORCEINLINE const List *Packets() const
+	FORCEINLINE const Tcont *Packets() const
 	{
 		return &this->packets;
 	}
@@ -227,15 +239,6 @@
 	}
 
 	/**
-	 * Returns source of the first cargo packet in this list.
-	 * @return The before mentioned source.
-	 */
-	FORCEINLINE StationID Source() const
-	{
-		return this->Empty() ? INVALID_STATION : this->packets.front()->source;
-	}
-
-	/**
 	 * Returns average number of days in transit for a cargo entity.
 	 * @return The before mentioned number.
 	 */
@@ -244,35 +247,46 @@
 		return this->count == 0 ? 0 : this->cargo_days_in_transit / this->count;
 	}
 
-
-	void Append(CargoPacket *cp);
+	void Append(CargoPacket *cp, bool update_cache = true);
 	void Truncate(uint max_remaining);
 
-	template <class Tother_inst>
-	bool MoveTo(Tother_inst *dest, uint count, MoveToAction mta, CargoPayment *payment, uint data = 0);
-
 	void InvalidateCache();
 };
 
+typedef std::list<CargoPacket *> CargoPacketList;
+
 /**
  * CargoList that is used for vehicles.
  */
-class VehicleCargoList : public CargoList<VehicleCargoList> {
+class VehicleCargoList : public CargoList<VehicleCargoList, CargoPacketList> {
 protected:
+
+	uint TransferPacket(Iterator &c, uint remaining_unload, StationCargoList *dest, CargoPayment *payment, StationID next);
+	uint DeliverPacket(Iterator &c, uint remaining_unload, CargoPayment *payment);
+	uint KeepPacket(Iterator &c);
+
 	/** The (direct) parent of this class. */
-	typedef CargoList<VehicleCargoList> Parent;
+	typedef CargoList<VehicleCargoList, CargoPacketList> Parent;
 
-	Money feeder_share; ///< Cache for the feeder share.
+	CargoPacketList reserved; ///< Packets reserved for unloading in this list.
+	Money feeder_share;       ///< Cache for the feeder share.
+	uint reserved_count;      ///< Cache for the number of reserved cargo entities.
 
 	void AddToCache(const CargoPacket *cp);
 	void RemoveFromCache(const CargoPacket *cp);
 
 public:
-	/** The super class ought to know what it's doing. */
-	friend class CargoList<VehicleCargoList>;
+	/** The station cargo list needs to control the unloading. */
+	friend class StationCargoList;
+	/** The super class ought to know what it's doing */
+	friend class CargoList<VehicleCargoList, CargoPacketList>;
 	/** The vehicles have a cargo list (and we want that saved). */
 	friend const struct SaveLoad *GetVehicleDescription(VehicleType vt);
 
+	~VehicleCargoList();
+
+	void OnCleanPool();
+
 	/**
 	 * Returns total sum of the feeder share for all packets.
 	 * @return The before mentioned number.
@@ -282,10 +296,68 @@
 		return this->feeder_share;
 	}
 
+	void Append(CargoPacket *cp, bool update_cache = true);
+
+	/**
+	 * Returns sum of cargo on board the vehicle (ie not only
+	 * reserved).
+	 * @return Cargo on board the vehicle.
+	 */
+	FORCEINLINE uint OnboardCount() const
+	{
+		return this->count - this->reserved_count;
+	}
+
+	/**
+	 * Returns sum of cargo reserved for the vehicle.
+	 * @return Cargo reserved for the vehicle.
+	 */
+	FORCEINLINE uint ReservedCount() const
+	{
+		return this->reserved_count;
+	}
+
+	/**
+	 * Returns a pointer to the reserved cargo list.
+	 * @return Pointer to the reserved list.
+	 */
+	FORCEINLINE const CargoPacketList *Reserved() const
+	{
+		return &this->reserved;
+	}
+
+	/**
+	 * Returns source of the first cargo packet in this list
+	 * If the regular packets list is empty but there are packets
+	 * in the reservation list it returns the source of the first
+	 * reserved packet.
+	 * @return The before mentioned source.
+	 */
+	FORCEINLINE StationID Source() const
+	{
+		if (this->Empty()) {
+			return INVALID_STATION;
+		} else if (this->packets.empty()) {
+			return this->reserved.front()->source;
+		} else {
+			return this->packets.front()->source;
+		}
+	}
+
+	void Reserve(CargoPacket *cp);
+
+	void Unreserve(StationID next, StationCargoList *dest);
+
+	uint LoadReserved(uint count);
+
+	void SwapReserved();
+
 	void AgeCargo();
 
 	void InvalidateCache();
 
+	uint MoveTo(VehicleCargoList *dest, uint cap);
+
 	/**
 	 * Are two the two CargoPackets mergeable in the context of
 	 * a list of CargoPackets for a Vehicle?
@@ -303,16 +375,21 @@
 	}
 };
 
+typedef MultiMap<StationID, CargoPacket *> StationCargoPacketMap;
+typedef std::map<StationID, uint> StationCargoAmountMap;
+
 /**
  * CargoList that is used for stations.
  */
-class StationCargoList : public CargoList<StationCargoList> {
+class StationCargoList : public CargoList<StationCargoList, StationCargoPacketMap> {
 public:
 	/** The super class ought to know what it's doing. */
-	friend class CargoList<StationCargoList>;
+	friend class CargoList<StationCargoList, StationCargoPacketMap>;
 	/** The stations, via GoodsEntry, have a CargoList. */
 	friend const struct SaveLoad *GetGoodsDesc();
 
+	StationCargoList() : station(NULL), cargo(INVALID_CARGO) {}
+
 	/**
 	 * Are two the two CargoPackets mergeable in the context of
 	 * a list of CargoPackets for a Vehicle?
@@ -327,6 +404,40 @@
 				cp1->source_type     == cp2->source_type &&
 				cp1->source_id       == cp2->source_id;
 	}
+
+	uint TakeFrom(VehicleCargoList *source, uint max_unload, OrderUnloadFlags flags, StationID next_station, bool has_stopped, CargoPayment *payment);
+
+	uint MoveTo(VehicleCargoList *dest, uint cap, StationID next_station, bool reserve = false);
+
+	void Append(StationID next, CargoPacket *cp);
+
+	void RerouteStalePackets(StationID to);
+
+	void CountAndTruncate(uint max_remaining, StationCargoAmountMap &cargo_per_source);
+
+	/**
+	 * Returns source of the first cargo packet in this list
+	 * @return The before mentioned source
+	 */
+	FORCEINLINE StationID Source() const
+	{
+		return this->Empty() ? INVALID_STATION : this->packets.begin()->second.front()->source;
+	}
+
+	void AssignTo(Station *station, CargoID cargo);
+
+	static void InvalidateAllFrom(SourceType src_type, SourceID src);
+
+protected:
+	Station *station; ///< Station this cargo list belongs to.
+	CargoID cargo;    ///< Cargo type this list holds.
+
+	byte GetUnloadFlags(OrderUnloadFlags order_flags);
+
+	UnloadType WillUnloadOld(byte flags, StationID source);
+	UnloadType WillUnloadCargoDist(byte flags, StationID next_station, StationID via, StationID source);
+
+	uint MovePackets(VehicleCargoList *dest, uint cap, Iterator begin, Iterator end, bool reserve);
 };
 
 #endif /* CARGOPACKET_H */
diff --git a/src/cheat_gui.cpp b/src/cheat_gui.cpp
--- a/src/cheat_gui.cpp
+++ b/src/cheat_gui.cpp
@@ -133,6 +133,7 @@
 /** Available cheats. */
 enum CheatNumbers {
 	CHT_MONEY,           ///< Change amount of money.
+	CHT_DAYLENGTH_INCOME,///< Do not devide income by daylength factor
 	CHT_CHANGE_COMPANY,  ///< Switch company.
 	CHT_EXTRA_DYNAMITE,  ///< Dynamite anything.
 	CHT_CROSSINGTUNNELS, ///< Allow tunnels to cross each other.
@@ -166,6 +167,7 @@
  */
 static const CheatEntry _cheats_ui[] = {
 	{SLE_INT32, STR_CHEAT_MONEY,           &_money_cheat_amount,                    &_cheats.money.been_used,            &ClickMoneyCheat         },
+	{SLE_BOOL,  STR_CHEAT_DAYLENGHT_INCOME,&_cheats.daylength_income.value,         &_cheats.daylength_income.been_used, NULL                     },
 	{SLE_UINT8, STR_CHEAT_CHANGE_COMPANY,  &_local_company,                         &_cheats.switch_company.been_used,   &ClickChangeCompanyCheat },
 	{SLE_BOOL,  STR_CHEAT_EXTRA_DYNAMITE,  &_cheats.magic_bulldozer.value,          &_cheats.magic_bulldozer.been_used,  NULL                     },
 	{SLE_BOOL,  STR_CHEAT_CROSSINGTUNNELS, &_cheats.crossing_tunnels.value,         &_cheats.crossing_tunnels.been_used, NULL                     },
diff --git a/src/cheat_type.h b/src/cheat_type.h
--- a/src/cheat_type.h
+++ b/src/cheat_type.h
@@ -29,6 +29,7 @@
 	Cheat magic_bulldozer;  ///< dynamite industries, objects
 	Cheat switch_company;   ///< change to another company
 	Cheat money;            ///< get rich or poor
+	Cheat daylength_income; ///< do not devide vehicle income by the daylength factor
 	Cheat crossing_tunnels; ///< allow tunnels that cross each other
 	Cheat dummy1;           ///< empty cheat (build while in pause mode)
 	Cheat no_jetcrash;      ///< no jet will crash on small airports anymore
diff --git a/src/clear_func.h b/src/clear_func.h
--- a/src/clear_func.h
+++ b/src/clear_func.h
@@ -17,4 +17,7 @@
 void DrawHillyLandTile(const TileInfo *ti);
 void DrawClearLandTile(const TileInfo *ti, byte set);
 
+/* copy_paste_gui.cpp */
+void ClearCopyArrays(uint32 w, uint32 h);
+
 #endif /* CLEAR_FUNC_H */
diff --git a/src/command.cpp b/src/command.cpp
--- a/src/command.cpp
+++ b/src/command.cpp
@@ -27,6 +27,8 @@
 #include "signal_func.h"
 #include "core/backup_type.hpp"
 #include "object_base.h"
+#include "window_func.h"
+#include "watch_gui.h"
 
 #include "table/strings.h"
 
@@ -171,8 +173,18 @@
 CommandProc CmdChangeTimetable;
 CommandProc CmdSetVehicleOnTime;
 CommandProc CmdAutofillTimetable;
+CommandProc CmdAutomateTimetable;
 CommandProc CmdSetTimetableStart;
 
+CommandProc CmdInsertSignalInstruction;
+CommandProc CmdModifySignalInstruction;
+CommandProc CmdRemoveSignalInstruction;
+
+CommandProc CmdSetSignalSpeedLimit;
+
+CommandProc CmdBuildTrafficLights;
+CommandProc CmdRemoveTrafficLights;
+
 #define DEF_CMD(proc, flags, type) {proc, #proc, flags, type}
 
 /**
@@ -304,7 +316,14 @@
 	DEF_CMD(CmdChangeTimetable,                                0, CMDT_ROUTE_MANAGEMENT      ), // CMD_CHANGE_TIMETABLE
 	DEF_CMD(CmdSetVehicleOnTime,                               0, CMDT_ROUTE_MANAGEMENT      ), // CMD_SET_VEHICLE_ON_TIME
 	DEF_CMD(CmdAutofillTimetable,                              0, CMDT_ROUTE_MANAGEMENT      ), // CMD_AUTOFILL_TIMETABLE
+	DEF_CMD(CmdAutomateTimetable,                              0, CMDT_ROUTE_MANAGEMENT      ), // CMD_AUTOMATE_TIMETABLE
 	DEF_CMD(CmdSetTimetableStart,                              0, CMDT_ROUTE_MANAGEMENT      ), // CMD_SET_TIMETABLE_START
+	DEF_CMD(CmdInsertSignalInstruction,                        0, CMDT_OTHER_MANAGEMENT      ), // CMD_INSERT_SIGNAL_INSTRUCTION
+	DEF_CMD(CmdModifySignalInstruction,                        0, CMDT_OTHER_MANAGEMENT      ), // CMD_MODIFY_SIGNAL_INSTRUCTION
+	DEF_CMD(CmdRemoveSignalInstruction,                        0, CMDT_OTHER_MANAGEMENT      ), // CMD_REMOVE_SIGNAL_INSTRUCTION
+	DEF_CMD(CmdSetSignalSpeedLimit,                            0, CMDT_OTHER_MANAGEMENT      ), // CMD_SET_SIGNAL_SPEED_LIMIT
+	DEF_CMD(CmdBuildTrafficLights,                             0, CMDT_LANDSCAPE_CONSTRUCTION), // CMD_BUILD_TRAFFICLIGHTS
+	DEF_CMD(CmdRemoveTrafficLights,						       0, CMDT_LANDSCAPE_CONSTRUCTION), // CMD_REMOVE_TRAFFICLIGHTS
 };
 
 /*!
@@ -714,6 +733,16 @@
 		if (c != NULL) c->last_build_coordinate = tile;
 	}
 
+	/* Send Tile Number to Watching Company Windows */
+	int watching_window = 0;
+	WatchCompany *wc;
+	wc = dynamic_cast<WatchCompany*>(FindWindowById(WC_WATCH_COMPANY, watching_window));
+	while (wc!=NULL) {
+		wc->OnDoCommand( _current_company, tile );
+		watching_window++;
+		wc = dynamic_cast<WatchCompany*>(FindWindowById(WC_WATCH_COMPANY, watching_window));
+	}
+
 	SubtractMoneyFromCompany(res2);
 
 	/* update signals if needed */
diff --git a/src/command_queue.cpp b/src/command_queue.cpp
new file mode 100644
--- /dev/null
+++ b/src/command_queue.cpp
@@ -0,0 +1,77 @@
+/* $Id: command_queue.cpp 4998 2006-05-30 16:15:17Z Frostregen $ */
+
+#include "stdafx.h"
+#include "tile_type.h"
+#include "command_type.h"
+#include "command_func.h"
+#include "debug.h"
+#include "copy_paste.h"
+#include "command_queue.h"
+#include "settings_type.h"
+#include "gfx_func.h"
+#include "date_func.h"
+
+CopyPasteCommandQueue::~CopyPasteCommandQueue()
+{
+	this->ClearCopyPasteCommandQueue();
+}
+
+/** Enqueue the given command.
+ * May be executed later by calling ExecuteNextCommand()
+ */
+void CopyPasteCommandQueue::CopyPasteQueueCommand(TileIndex tile, uint32 p1, uint32 p2, CommandCallback *callback, uint32 cmd)
+{
+	CommandContainer *cc = new CommandContainer;
+	
+	cc->tile = tile;
+	cc->p1   = p1;
+	cc->p2   = p2;
+	cc->callback = callback;
+	cc->cmd  = cmd;
+	
+	/* add it to the queue */
+	this->queue.push(cc);
+}
+
+/** Executes the next queued command, or does nothing if queue is emtpy
+ * Since DoCommandP checks for _shift_pressed,
+ * we have to store, unset und restore it.
+ */
+void CopyPasteCommandQueue::ExecuteNextCommand()
+{
+	/* Check if queue is not empty */
+	if (!this->queue.empty()) {
+		/* backup and unset _shift_pressed */
+		bool temp_shift_pressed = _shift_pressed;
+		_shift_pressed = false;
+		/* Get the command and execute it */
+		DoCommandP(this->queue.front());
+		/* restore _shift_pressed */
+		_shift_pressed = temp_shift_pressed;
+		/* delete this commandcontainer */
+		{
+			CommandContainer *cc = this->queue.front();
+			this->queue.pop();
+			delete cc;
+		}
+	}
+}
+
+/** Clears the CopyPasteCommandQueue
+ */
+void CopyPasteCommandQueue::ClearCopyPasteCommandQueue()
+{
+	while (!this->queue.empty()) {
+		this->queue.pop();
+	}
+}
+
+void CallCopyPasteCommandQueueTick()
+{
+	/* Process the command_queue */
+	if (_settings_client.gui.cp_paste_speed < 255) {
+		if ((_tick_counter % _settings_client.gui.cp_paste_speed) == 0) {
+			_copy_paste_command_queue.ExecuteNextCommand();
+		}
+	}
+}
diff --git a/src/command_queue.h b/src/command_queue.h
new file mode 100644
--- /dev/null
+++ b/src/command_queue.h
@@ -0,0 +1,28 @@
+/* $Id: command_queue.h 4998 2006-05-30 16:13:41Z Frostregen $ */
+
+#ifndef COMMAND_QUEUE_H
+#define COMMAND_QUEUE_H
+
+#include "map_type.h"
+#include "command_type.h"
+#include "settings_type.h"
+#include <queue>
+
+class CopyPasteCommandQueue {
+private:
+	std::queue<CommandContainer *> queue;
+
+public:
+	~CopyPasteCommandQueue();
+
+	void ClearCopyPasteCommandQueue();        ///< Clears the CommandQueue
+
+	void CopyPasteQueueCommand(TileIndex tile, uint32 p1, uint32 p2, CommandCallback *callback, uint32 cmd); ///< Enqueue the given command.
+	void ExecuteNextCommand();       ///< Executes the next queued command, or does nothing if queue is emtpy
+};
+
+extern CopyPasteCommandQueue _copy_paste_command_queue;
+
+void CallCopyPasteCommandQueueTick();
+
+#endif /* COMMAND_QUEUE_H */
diff --git a/src/command_type.h b/src/command_type.h
--- a/src/command_type.h
+++ b/src/command_type.h
@@ -291,8 +291,18 @@
 	CMD_CHANGE_TIMETABLE,             ///< change the timetable for a vehicle
 	CMD_SET_VEHICLE_ON_TIME,          ///< set the vehicle on time feature (timetable)
 	CMD_AUTOFILL_TIMETABLE,           ///< autofill the timetable
+	CMD_AUTOMATE_TIMETABLE,           ///< automate the timetable
 	CMD_SET_TIMETABLE_START,          ///< set the date that a timetable should start
 
+	CMD_INSERT_SIGNAL_INSTRUCTION,    ///< insert a signal instruction
+	CMD_MODIFY_SIGNAL_INSTRUCTION,    ///< modifies a signal instruction
+	CMD_REMOVE_SIGNAL_INSTRUCTION,    ///< removes a signal instruction
+
+	CMD_SET_SIGNAL_SPEED_LIMIT,       ///< sets the value of a speed-signal
+
+	CMD_BUILD_TRAFFICLIGHTS,          ///< place traffic lights on a road crossing
+	CMD_REMOVE_TRAFFICLIGHTS,         ///< remove traffic lights
+
 	CMD_END                           ///< Must ALWAYS be on the end of this list!! (period)
 };
 
diff --git a/src/company_base.h b/src/company_base.h
--- a/src/company_base.h
+++ b/src/company_base.h
@@ -146,6 +146,30 @@
 	static void PostDestructor(size_t index);
 };
 
+struct CompanyProfile {
+	char president_name[MAX_LENGTH_PRESIDENT_NAME_CHARS];
+	char company_name[MAX_LENGTH_COMPANY_NAME_CHARS];
+	CompanyManagerFace face;
+	Livery livery[LS_END];
+
+	StringID error_id;
+
+	CompanyProfile()
+	{
+		this->error_id = STR_NULL;
+	}
+
+	CompanyProfile(StringID err)
+	{
+		this->error_id = err;
+	}
+};
+
+CompanyProfile GetCompanyProfile (const Company&);
+StringID       SetCompanyProfile (const CompanyProfile&);
+StringID       CompanyLoadProfile(CompanyProfile&);
+StringID       CompanySaveProfile(const CompanyProfile&);
+
 #define FOR_ALL_COMPANIES_FROM(var, start) FOR_ALL_ITEMS_FROM(Company, company_index, var, start)
 #define FOR_ALL_COMPANIES(var) FOR_ALL_COMPANIES_FROM(var, 0)
 
diff --git a/src/company_cmd.cpp b/src/company_cmd.cpp
--- a/src/company_cmd.cpp
+++ b/src/company_cmd.cpp
@@ -63,6 +63,7 @@
 
 	for (uint j = 0; j < 4; j++) this->share_owners[j] = COMPANY_SPECTATOR;
 	InvalidateWindowData(WC_PERFORMANCE_DETAIL, 0, INVALID_COMPANY);
+	InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
 }
 
 /** Destructor. */
@@ -82,6 +83,7 @@
 	InvalidateWindowData(WC_GRAPH_LEGEND, 0, (int)index);
 	InvalidateWindowData(WC_PERFORMANCE_DETAIL, 0, (int)index);
 	InvalidateWindowData(WC_COMPANY_LEAGUE, 0, 0);
+	InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
 	/* If the currently shown error message has this company in it, then close it. */
 	InvalidateWindowData(WC_ERRMSG, 0);
 }
@@ -141,7 +143,8 @@
  * @param cmf the fact to check
  * @return true if and only if the face is valid
  */
-static bool IsValidCompanyManagerFace(CompanyManagerFace cmf)
+//static bool IsValidCompanyManagerFace(CompanyManagerFace cmf) // r20689 TODO: check
+bool IsValidCompanyManagerFace(CompanyManagerFace cmf) // revert r20689 to be able to compile company_info patch
 {
 	if (!AreCompanyManagerFaceBitsValid(cmf, CMFV_GEN_ETHN, GE_WM)) return false;
 
@@ -212,14 +215,16 @@
 	if (HasBit(1 << EXPENSES_TRAIN_INC    |
 	           1 << EXPENSES_ROADVEH_INC  |
 	           1 << EXPENSES_AIRCRAFT_INC |
-	           1 << EXPENSES_SHIP_INC, cost.GetExpensesType())) {
+	           1 << EXPENSES_SHIP_INC     |
+			   1 << EXPENSES_SHARING_INC, cost.GetExpensesType())) {
 		c->cur_economy.income -= cost.GetCost();
 	} else if (HasBit(1 << EXPENSES_TRAIN_RUN    |
 	                  1 << EXPENSES_ROADVEH_RUN  |
 	                  1 << EXPENSES_AIRCRAFT_RUN |
 	                  1 << EXPENSES_SHIP_RUN     |
 	                  1 << EXPENSES_PROPERTY     |
-	                  1 << EXPENSES_LOAN_INT, cost.GetExpensesType())) {
+	                  1 << EXPENSES_LOAN_INT     |
+					  1 << EXPENSES_SHARING_COST, cost.GetExpensesType())) {
 		c->cur_economy.expenses -= cost.GetCost();
 	}
 
@@ -563,6 +568,8 @@
 
 	if (is_ai && (!_networking || _network_server)) AI::StartNew(c->index);
 
+	if (!is_ai) UpdateAllTownVirtCoords();
+
 	return c;
 }
 
@@ -1084,6 +1091,7 @@
 		free(c->name);
 		c->name = reset ? NULL : strdup(text);
 		MarkWholeScreenDirty();
+		InvalidateWindowClassesData(WC_WATCH_COMPANY, 0);
 		CompanyAdminUpdate(c);
 	}
 
diff --git a/src/company_gui.cpp b/src/company_gui.cpp
--- a/src/company_gui.cpp
+++ b/src/company_gui.cpp
@@ -54,6 +54,8 @@
 	EXPENSES_AIRCRAFT_INC,
 	EXPENSES_SHIP_INC,
 	EXPENSES_LOAN_INT,
+	EXPENSES_SHARING_INC,
+	EXPENSES_SHARING_COST,
 	EXPENSES_OTHER,
 };
 
@@ -63,6 +65,7 @@
 	EXPENSES_ROADVEH_INC,
 	EXPENSES_AIRCRAFT_INC,
 	EXPENSES_SHIP_INC,
+	EXPENSES_SHARING_INC,
 	INVALID_EXPENSES,
 	EXPENSES_TRAIN_RUN,
 	EXPENSES_ROADVEH_RUN,
@@ -70,6 +73,7 @@
 	EXPENSES_SHIP_RUN,
 	EXPENSES_PROPERTY,
 	EXPENSES_LOAN_INT,
+	EXPENSES_SHARING_COST,
 	INVALID_EXPENSES,
 	EXPENSES_CONSTRUCTION,
 	EXPENSES_NEW_VEHICLES,
@@ -1633,6 +1637,9 @@
 	CW_WIDGET_SELECT_RELOCATE,    ///< View/hide the 'Relocate HQ' button.
 	CW_WIDGET_RELOCATE_HQ,
 
+	CW_WIDGET_PROFILE_LOAD,       ///< Load a company profile
+	CW_WIDGET_PROFILE_SAVE,       ///< Save a company profile
+
 	CW_WIDGET_HAS_PASSWORD,       ///< Draw a lock when the company has a password
 	CW_WIDGET_SELECT_MULTIPLAYER, ///< Multiplayer selection panel.
 	CW_WIDGET_COMPANY_PASSWORD,
@@ -1679,6 +1686,9 @@
 							NWidget(WWT_TEXTBTN, COLOUR_GREY, CW_WIDGET_RELOCATE_HQ), SetFill(1, 0), SetDataTip(STR_COMPANY_VIEW_RELOCATE_HQ, STR_COMPANY_VIEW_RELOCATE_COMPANY_HEADQUARTERS),
 							NWidget(NWID_SPACER), SetMinimalSize(90, 0),
 						EndContainer(),
+						/* Company Profile buttons */
+						NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, CW_WIDGET_PROFILE_LOAD), SetFill(1, 0), SetDataTip(STR_COMPANY_PROFILE_LOAD_BUTTON, STR_COMPANY_PROFILE_LOAD_TOOLTIP),
+						NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, CW_WIDGET_PROFILE_SAVE), SetFill(1, 0), SetDataTip(STR_COMPANY_PROFILE_SAVE_BUTTON, STR_COMPANY_PROFILE_SAVE_TOOLTIP),
 						NWidget(NWID_SPACER), SetFill(0, 1),
 					EndContainer(),
 				EndContainer(),
@@ -1812,6 +1822,10 @@
 		}
 
 		if (!local) {
+			/* Not the current player, so disable profile loading/saving */
+			this->SetWidgetDisabledState(CW_WIDGET_PROFILE_LOAD, true);
+			this->SetWidgetDisabledState(CW_WIDGET_PROFILE_SAVE, true);
+
 			if (_settings_game.economy.allow_shares) { // Shares are allowed
 				/* If all shares are owned by someone (none by nobody), disable buy button */
 				this->SetWidgetDisabledState(CW_WIDGET_BUY_SHARE, GetAmountOwnedBy(c, INVALID_OWNER) == 0 ||
@@ -2014,6 +2028,45 @@
 				this->SetWidgetDirty(CW_WIDGET_RELOCATE_HQ);
 				break;
 
+			case CW_WIDGET_PROFILE_LOAD:	// When load is clicked we want to perform most of the operations from above!
+			{
+				StringID       error_id;
+				CompanyProfile company_profile;
+
+				if ((byte)this->window_number != _local_company) return;
+
+				this->LowerWidget(CW_WIDGET_PROFILE_LOAD);
+				//this->SetWidgetDirty(CW_WIDGET_PROFILE_LOAD);
+
+				error_id = CompanyLoadProfile(company_profile);
+				if (error_id == STR_NULL) error_id = SetCompanyProfile(company_profile); // No error, so try setting the profile
+				
+				/* If either CompanyProfileLoad or SetCompanyProfile have an error, they will be handled here */
+				if (error_id != STR_NULL) ShowErrorMessage(error_id, error_id, WL_INFO); 
+
+				this->LowerWidget(CW_WIDGET_PROFILE_LOAD);
+				//this->SetWidgetDirty(CW_WIDGET_PROFILE_LOAD);
+				break;
+			}
+
+			case CW_WIDGET_PROFILE_SAVE: 
+			{
+				StringID       error_id;
+				CompanyProfile company_profile;
+
+				if ((byte)this->window_number != _local_company) return;
+
+				this->LowerWidget(CW_WIDGET_PROFILE_SAVE);
+
+				company_profile = GetCompanyProfile(*_company_pool.Get(_local_company));
+				error_id = CompanySaveProfile(company_profile);
+
+				if (error_id != STR_NULL) ShowErrorMessage(error_id, error_id, WL_INFO);	
+
+				this->LowerWidget(CW_WIDGET_PROFILE_SAVE);
+				break;
+			}
+
 			case CW_WIDGET_BUY_SHARE:
 				DoCommandP(0, this->window_number, 0, CMD_BUY_SHARE_IN_COMPANY | CMD_MSG(STR_ERROR_CAN_T_BUY_25_SHARE_IN_THIS));
 				break;
diff --git a/src/company_manager_face.h b/src/company_manager_face.h
--- a/src/company_manager_face.h
+++ b/src/company_manager_face.h
@@ -237,6 +237,7 @@
 	return _cmf_info[cmfv].first_sprite[ge] + GB(cmf, _cmf_info[cmfv].offset, _cmf_info[cmfv].length);
 }
 
+bool IsValidCompanyManagerFace(CompanyManagerFace cmf); // revert r20689 to be able to compile company_info patch
 void DrawCompanyManagerFace(CompanyManagerFace face, int colour, int x, int y);
 
 #endif /* COMPANY_MANAGER_FACE_H */
diff --git a/src/console_cmds.cpp b/src/console_cmds.cpp
--- a/src/console_cmds.cpp
+++ b/src/console_cmds.cpp
@@ -1166,6 +1166,79 @@
 	return true;
 }
 
+DEF_CONSOLE_CMD(ConStartAllAI)
+{
+	if (argc == 0 || argc > 2) {
+		IConsoleHelp("Start all AI. Usage: 'start_ai [<AI count>]'");
+		IConsoleHelp("Start all AI. If <AI count> is given, it starts AIs up to reach this count of running AIs.");
+		IConsoleHelp("Otherwise, the competitor setting is used.");
+		return true;
+	}
+
+	if (_game_mode != GM_NORMAL) {
+		IConsoleWarning("AIs can only be managed in a game.");
+		return true;
+	}
+
+	if (Company::GetNumItems() == CompanyPool::MAX_SIZE) {
+		IConsoleWarning("Can't start a new AI (no more free slots).");
+		return true;
+	}
+
+	if (_networking && !_network_server) {
+		IConsoleWarning("Only the server can start a new AI.");
+		return true;
+	}
+
+	if (_networking && !_settings_game.ai.ai_in_multiplayer) {
+		IConsoleWarning("AIs are not allowed in multiplayer by configuration.");
+		IConsoleWarning("Switch AI -> AI in multiplayer to True.");
+		return true;
+	}
+
+	if (!AI::CanStartNew()) {
+		IConsoleWarning("Can't start a new AI.");
+		return true;
+	}
+
+	int total_ai_count;
+	if (argc == 2) {
+		uint32 result;
+		if (GetArgumentInteger(&result, argv[1]) && result < CompanyPool::MAX_SIZE) {
+			total_ai_count = (int)result;
+		} else {
+			IConsolePrintF(CC_DEFAULT, "AI count must be an number between 1 and %d", CompanyPool::MAX_SIZE - 1);
+			IConsoleWarning("Invalid AI count");
+			return true;
+		}
+	} else {
+		total_ai_count = (int)_settings_game.difficulty.max_no_competitors;
+	}
+
+	/* Total AI to start is total_ai_count - current running AIs count */
+	int new_ai_count = total_ai_count;
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		if (Company::IsValidAiID(c->index)) {
+			new_ai_count--;
+		}
+	}
+
+	if (new_ai_count < 0) {
+		IConsolePrintF(CC_DEFAULT, "Desired a total if %d AIs. Already %d running AIs.", total_ai_count, total_ai_count - new_ai_count);
+		IConsoleWarning("There is already more AIs running than you requested for.");
+		return true;
+	}
+
+	/* Start the desired AIs */
+	IConsolePrintF(CC_DEFAULT, "Desired a total if %d AIs. Already %d running AIs, starting %d new AIs.", total_ai_count, total_ai_count - new_ai_count, new_ai_count);
+	for (int i = 0; i < new_ai_count; i++) {
+		DoCommandP(0, 1 | INVALID_COMPANY << 16, 0, CMD_COMPANY_CTRL);
+	}
+
+	return true;
+}
+
 DEF_CONSOLE_CMD(ConReloadAI)
 {
 	if (argc != 2) {
@@ -1203,6 +1276,34 @@
 	return true;
 }
 
+DEF_CONSOLE_CMD(ConReloadAllAI)
+{
+	if (_game_mode != GM_NORMAL) {
+		IConsoleWarning("AIs can only be managed in a game.");
+		return true;
+	}
+
+	if (_networking && !_network_server) {
+		IConsoleWarning("Only the server can reload an AI.");
+		return true;
+	}
+
+	CompanyID company_id;
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		company_id = c->index;
+		if (Company::IsValidID(company_id) && !Company::IsHumanID(company_id)) {
+			/* First kill the company of the AI, then start a new one. This should start the current AI again */
+			DoCommandP(0, 2 | company_id << 16, 0, CMD_COMPANY_CTRL);
+			DoCommandP(0, 1 | company_id << 16, 0, CMD_COMPANY_CTRL);
+		}
+	}
+
+	IConsolePrint(CC_DEFAULT, "All AIs reloaded.");
+
+	return true;
+}
+
 DEF_CONSOLE_CMD(ConStopAI)
 {
 	if (argc != 2) {
@@ -1239,6 +1340,33 @@
 	return true;
 }
 
+DEF_CONSOLE_CMD(ConStopAllAI)
+{
+	if (_game_mode != GM_NORMAL) {
+		IConsoleWarning("AIs can only be managed in a game.");
+		return true;
+	}
+
+	if (_networking && !_network_server) {
+		IConsoleWarning("Only the server can stop an AI.");
+		return true;
+	}
+
+	CompanyID company_id;
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		company_id = c->index;
+		if (Company::IsValidID(company_id) && !Company::IsHumanID(company_id)) {
+			/* Now kill the company of the AI. */
+			DoCommandP(0, 2 | company_id << 16, 0, CMD_COMPANY_CTRL);
+			IConsolePrintF(CC_DEFAULT, "AI stopped, company %d deleted.", company_id);
+		}
+
+	}
+
+	return true;
+}
+
 DEF_CONSOLE_CMD(ConRescanAI)
 {
 	if (argc == 0) {
@@ -1896,11 +2024,14 @@
 
 #ifdef ENABLE_AI
 	IConsoleCmdRegister("list_ai_libs", ConListAILibs);
-	IConsoleCmdRegister("list_ai",      ConListAI);
-	IConsoleCmdRegister("reload_ai",    ConReloadAI);
-	IConsoleCmdRegister("rescan_ai",    ConRescanAI);
-	IConsoleCmdRegister("start_ai",     ConStartAI);
-	IConsoleCmdRegister("stop_ai",      ConStopAI);
+	IConsoleCmdRegister("list_ai",       ConListAI);
+	IConsoleCmdRegister("reload_ai",     ConReloadAI);
+	IConsoleCmdRegister("reload_all_ai", ConReloadAllAI);
+	IConsoleCmdRegister("rescan_ai",     ConRescanAI);
+	IConsoleCmdRegister("start_ai",      ConStartAI);
+	IConsoleCmdRegister("start_all_ai",  ConStartAllAI);
+	IConsoleCmdRegister("stop_ai",       ConStopAI);
+	IConsoleCmdRegister("stop_all_ai",   ConStopAllAI);
 #endif /* ENABLE_AI */
 
 	/* networking functions */
